<!DOCTYPE html>
<?php

// An users editing program; just to fill a database, and serve up the data to the CocoaApp. Nothing more, nothing less. 
// For creation:
// /usr/local/bin/createdb testnfcuid -E UTF8
// psql testnfcuid < testnfcuid.pgsql
// make sure that php is compiled with postgresql support: check with  a script info.php with contents phpinfo(); 
// See info.php in this folder for an example
// put the script(s) into /usr/local/www/data/htdocs on a stock *N*X apache server, or your configured folder that is supposed to support php scripts
// put the script(s) into /Library/WebServer/Documents on a stock Mac Server, or your configured folder that is supposed to support php scripts

$table = 'contacts';

// Make sure there is a webserver configured with file_location as root folder
// tow subfolders: images and scripts. Images should be writable by the apache server
// place the scripts in a subfolder scripts.

$file_location='/usr/local/www/data/readrfid/images';
// On a stock linux apache server this file_location should be OK. 
//$file_location='/usr/share/apache2/default-site/images';
// FreeBSD:
//$file_location='/usr/local/www/apache22/data/images';
// In a Mac OS X Machine pre 10.7 this should be an ok location. 
//$file_location='/Libray/WebServer/Documents/images';

if(!file_exists($file_location)){
	if(!mkdir($file_location, 0, true) ) {
	    die('Failed to create image folder ['.$file_location.'] Make sure the webserver has read/write rights to the parent folder');
	}
} else if(!is_writable($file_location)){
	die('Cannot write into the images folder ['.$file_location.'], Make sure the webserver has read/write rights to the parent folder');
}

// the path via which the images can be found. I use slashes in the beginning and the end of the path,
// so the variables are easier to concatenate.
$webpath='/images/';
$firstname = "";
$lastname = "";
$email = "";
$address = "";
$zipcode = "";
$city = "";
$datestarted = "";
$nfcuid = "";
$nfctagtype = "";
$id="";
$ext="";

$conn=pg_connect ("host=localhost port=5432 dbname=testnfcuid user='root' password=''");

if(!$conn){
	die("Can not connect to database");
}


// This function makes usage of
// $_GET, $_POST, etc... variables
// completly safe in SQL queries
function sql_safe($s)
{
    if (get_magic_quotes_gpc()) {
        $s = stripslashes($s);
	}
    return pg_escape_string($s);
}


// If user pressed submit in one of the forms
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    // variable we use to make a difference between web output and output to the readrfid app.
    if(isset($_POST['readrfid']))
    $readrfid = trim(sql_safe($_POST['readrfid']));

    if(isset($_POST['checkreadrfid']))
    $checkreadrfid = trim(sql_safe($_POST['checkreadrfid']));
	
    // cleaning firstname field
    if(isset($_POST['firstname']))
    $firstname = trim(sql_safe($_POST['firstname']));
    // cleaning lastname field
    if(isset($_POST['lastname']))
    $lastname = trim(sql_safe($_POST['lastname']));
    // cleaning nfcuid field
    if(isset($_POST['nfcuid']))
    $nfcuid = trim(sql_safe($_POST['nfcuid']));
    // cleaning nfctagtype field
    if(isset($_POST['nfctagtype']))
    $nfctagtype = trim(sql_safe($_POST['nfctagtype']));
    // cleaning email field
    if(isset($_POST['email']))
    $email = trim(sql_safe($_POST['email']));
    // cleaning address field
    if(isset($_POST['address']))
    $address = trim(sql_safe($_POST['address']));
    // cleaning zipcode field
    if(isset($_POST['zipcode']))
    $zipcode = trim(sql_safe($_POST['zipcode']));
    // cleaning city field
    if(isset($_POST['city']))
    $city = trim(sql_safe($_POST['city']));
    // cleaning datestarted field
    if(isset($_POST['datestarted']))
    $datestarted = trim(sql_safe($_POST['datestarted']));

    if ($nfcuid == '') {// if nfcuid is not set
        $msg = 'Error: Please fill in all the fields.';
	}
    if ($nfctagtype == '') {// if nfctagtype is not set
        $msg = 'Error: Please fill in all the fields.';
	}

    if(!isset($_POST['checkreadrfid'])){
	    if ($firstname == '') {// if firstname is not set
	        $msg = 'Error: Please fill in all the fields.';
		}

	    if ($lastname == '') { // if lasstname is not set
   			$msg = 'Error: Please fill in all the fields.>';
		}

	    if (isset($_FILES['photo'])) {
	   	 	@list(, , $imtype, ) = getimagesize($_FILES['photo']['tmp_name']);
        // Get image type.
        // We use @ to omit errors
	    
	        if ($imtype == 3){ // cheking image type
	        	$ext="png";   // to use it later in HTTP headers
	        } elseif ($imtype == 2) {
				$ext="jpeg";
			} elseif ($imtype == 1) {
				$ext="gif";
	    	} elseif ($imtype == 10) {
	    		$ext="jp2";
	    	} else {
				$msg = $msg.'Error: no image uploaded or unknown image format';
			}
	    	if (!isset($msg)) { // If there was no error
			//first check if the nfcuid and tagtype have not been added already to the database
	            $results=pg_query($conn,"SELECT c_first_name, c_last_name, c_email, c_address, c_zipcode, c_city, c_nfcuid, c_nfctagtype  from  {$table} WHERE  c_nfcuid = '$nfcuid' and c_nfctagtype = '$nfctagtype' ");
				if(!$results){
				   $msg = 'Error searching nfctagtype in database';
				} else if (pg_num_rows($results) > 0) {
					list($firstname, $lastname, $email, $address, $zipode, $city, $nfcuid, $nfctagtype) = pg_fetch_row($results);
				   $msg = "Error nfctagtype ".$nfctagtype." nfcuid ".$nfcuid."  already in database, for user ".$firstname." ".$lastname." ";
				} else {
		    		$data = file_get_contents($_FILES['photo']['tmp_name']);
        	    // Preparing data to be used in posgresql query
					$escaped = bin2hex( $data);
		            $resulti=pg_query($conn,"INSERT INTO {$table} (id, c_ext, c_first_name, c_last_name, c_email, c_address, c_zipcode, c_city, c_nfcuid, c_nfctagtype, c_data) VALUES ( nextval('contacts_id_seq'), '$ext', '$firstname' , '$lastname', '$email', '$address', '$zipcode', '$city' ,'$nfcuid', '$nfctagtype', decode('{$escaped}' , 'hex') )");
					if(!$resulti){
					   $msg = 'Error inserting user into database';
					} else {
						$msg = "Success: user ".$firstname." ".$lastname." added";
					}
				}
			}
		} elseif ( isset($_POST['nfcuid']) ) {     // isset(..nfcuid) needed to make sure we've using upload form, not form for deletion
	        $msg = $msg.'Error: file not loaded';     
		}
	}
    if (isset($_POST['del'])) { // delete user
		$id = intval($_POST['del']);
		$resultd=pg_query($conn, "DELETE FROM {$table} WHERE id=$id");
		if (!$resultd){
			$msg = 'Error, could not delete user';
		} else {
			$msg = 'Success: User deleted';
		}
    }
    
// the server request is a get, which means we search for the data of a specific user
} elseif (isset($_GET['show'])) {
	$id = intval($_GET['show']);
	$result = pg_query($conn, "SELECT id, c_ext, c_image_time, encode(c_data,'base64') AS data  FROM {$table}  WHERE id='$id' LIMIT 1");

    if (pg_num_rows($result) == 0) {
    	$msg='Error retrieving user';
    } else {
	list($id, $ext, $image_time, $data) = pg_fetch_row($result);
   		// check if the user picture exists. If not, we will take it out of the database
	    $filepath=$file_location.'/'.$id.'.'.$ext;
		if(!is_file($filepath) || filemtime($filepath) < strtotime($image_time) ) {
	    	$rawdata=base64_decode($data);
    		$fileresult=file_put_contents($filepath,$rawdata,LOCK_EX);
    	}
    	#echo $fileresult."<br/>\n";
    }
}
// only display webinterface if ReadRfid cocoaapp is not sending the requests
if(!isset($_POST['readrfid'])){
?>
<html><head>
<title>NFC-UID Example</title>
</head>
<body>
<h1>NFC-UID Example</h1>
<p>This is a quick and dirty way to upload images and the data of people into a database. Make sure 
you have a folder images in you webserver where the images can be uploaded, and php compiled with postgresql included </p>

<p>current folder where the images get uploaded: [<?php echo "$file_location";?>]</p>

<p><b>Never ever use this in the real world, it is not meant to be used for anything else as to demonstrate that READRFID works.</b></p>

<?php
}
if (isset($msg)) { // this is special section for
                 // outputing message
     if (stristr($msg, 'error')){ 
	        if(!isset($_POST['readrfid'])){
?>
<p style="font-weight: bold; 	background-color: red;"><?=$msg?>
<br/>
<!-- I've added reloading link, because
     refreshing POST queries is not good idea -->
</p>
<?php
		} else  {
			echo "ANSWER\tERROR\t$msg\n";
		}
	// the error message is not an error, just a message
	} else {
	        if(!isset($_POST['readrfid'])){
?>
<p style="font-weight: bold; 	background-color: green;"><?=$msg?>
<br/>
<!-- I've added reloading link, because
     refreshing POST queries is not good idea -->
</p>
<?php
		} else  {
			echo "ANSWER\tYES\t$msg\n";
		}
	
	}
	
}
?>
<?php 
// only output browser info if the request is not from the CocoaApp
if(!isset($_POST['readrfid'])){
?>
<a href="<?=$_SERVER['PHP_SELF']?>">reload page</a>
<h2>Create new user and upload image:</h2>
<form action="<?=$_SERVER['PHP_SELF']?>" method="POST" enctype="multipart/form-data">
<label for="firstname">Firstname</label>, <label for="lastname">Lastname:</label><br/>
	<?php
    	if ($firstname == '') {// if title is not set
	?>
	<span class="errorfirstname" style=" color: red;">*</span>
	<?php
		}
	?>
<input type="text" name="firstname" id="firstname" size="24"> 
	<?php
    	if ($lastname == '') {// if title is not set
	?>
		<span class="errorlastname" style=" color: red;">*</span>
	<?php
		}
	?>
<input type="text" name="lastname" id="lastname" size="64"><br/><br/>

<label for="nfcuid">nfcuid:</label><br/>
	<?php
    	if ($nfcuid == '') {// if title is not set
	?>
		<span class="errornfcuid" style=" color: #red;">*</span>
	<?php
		}
	?>
<input type="text" name="nfcuid" id="nfcuid" size="40" maxlength="78"><br/><br/>

<label for="nfctagtype">nfctagtype:</label><br/>
	<?php
    	if ($nfctagtype == '') {// if title is not set
	?>
		<span class="errornfctagtype" style=" color: red;">*</span>
	<?php
		}
	?>
<input type="text" name="nfctagtype" id="nfctagtype" size="40" maxlength="256"><br/><br/>

<label for="photo">Photo:</label><br/>
<input type="file" name="photo" id="photo"><br/><br/>

<input type="submit" value="upload">
</form>
<hr/>
<h2>Existing People:</h2>

<form action="<?=$_SERVER['PHP_SELF']?>" method="post">
<!-- This form is used for image deletion -->

<?php
	$result = pg_query($conn,"SELECT id, c_first_name, c_last_name, c_nfcuid, c_nfctagtype, c_image_time FROM {$table} ORDER BY id DESC");
	if(!$result){
		$msg='An error while retrieving info from the database';
	}
	if ( pg_num_rows($result) == 0) { // table is empty
   		echo '<ul><li>No people available</li></ul>';
	} else {
    // we selected a user, so we try to get the image
    	if($id !="" && $ext !=""){
	        echo '<img src ="'.$webpath.$id.'.'.$ext.'">';
	    }
   		echo '<ul>';
	    while(list($id, $firstname, $lastname, $nfcuid, $nfctagtype, $image_time) = pg_fetch_row($result)) {
        // outputing list
    	    echo "<li><input type='radio' name='del' value='{$id}'>";
	        echo "<a href='{$_SERVER['PHP_SELF']}?show={$id}'>{$firstname} {$lastname} uid: [{$nfcuid}] tagtype: [{$nfctagtype}]</a> &ndash; ";
	        echo "<small>{$image_time}</small></li>";
    	}
	    echo '</ul>';
	    echo '<input type="submit" value="Delete selected">';
	    echo '<hr>';
	}
?>

</form>
<?php
// we do not use the webinterface
} else {
	if(isset($_POST['checkreadrfid'])){
		$result = pg_query($conn,"SELECT id, c_first_name, c_last_name, c_nfcuid, c_nfctagtype, c_ext, c_image_time, encode(c_data,'base64') AS data FROM {$table} WHERE c_nfcuid = '$nfcuid' and c_nfctagtype = '$nfctagtype' ORDER BY id DESC");
		if(!$result){
			echo $msg='ANSWER\tERROR\tError while retrieving info from the database\n';
		}
		if ( pg_num_rows($result) == 0) { // table is empty
		    echo $msg="ANSWER\tNO\tThis tag is not registered: if you want to register a person with this tag, please add the person\n";
//		    echo "".$msg."";
		} else {
			list($id, $firstname, $lastname, $nfcuid, $nfctagtype, $ext, $image_time, $data) = pg_fetch_row($result);
	   		// check if the user picture exists. If not, we will take it out of the database
		    $filepath=$file_location.'/'.$id.'.'.$ext;
			if(!is_file($filepath) || filemtime($filepath) < strtotime($image_time) ) {
		    	$rawdata=base64_decode($data);
   		 		$fileresult=file_put_contents($filepath,$rawdata,LOCK_EX);
    		}

	    	$msg="ANSWER\tYES\tWelcome ".$firstname." ".$lastname." ".$email."\n";
   		 	echo "".$msg."";
			$serverurl="http://".$_SERVER['SERVER_NAME'];
			$imageurl=$serverurl.$webpath.$id.".".$ext;
			echo "IMG\t".$imageurl."\n";
		}
	}
}
?>

</body>
</html>